#include "mbed.h"


#if !defined(POST_APPLICATION_ADDR)
#error "target.restrict_size must be set for your target in mbed_app.json"
#endif


//FlashIAP flash;  
void apply_update(Serial *ps, uint32_t address);
int main()
{
		uint8_t sByte[7];
		int count=0;
		Serial *pc = new Serial(USBTX, USBRX); // tx, rx
		Timer *t = new Timer;
		pc->baud(57600);
		pc->printf("GPD - Bootloader... \r\n");
		pc->printf("Wait 10 sec for update\r\n");
        
		t->reset();
		t->start();
		
		while(t->read()<10)
		{
			if(pc->readable()==1)
			{
				
				sByte[count] = pc->getc();
				count++;
				if(count==7)
				{
					if((sByte[0]=='U')&&(sByte[1]=='P')&&(sByte[2]=='D')&&(sByte[3]=='A')&&(sByte[4]=='T')&&(sByte[5]=='E')&&(sByte[6]=='\n'))
					{
						while(pc->readable()){ pc->getc(); }
						while(pc->readable()){ pc->getc(); }
						pc->printf("Ready to receive firmware update...\r\n");
						apply_update(pc,POST_APPLICATION_ADDR);
						
						break;
					}
				}
			}
		}
		t->stop();

		pc->printf("Starting application at address [%X] \r\n",POST_APPLICATION_ADDR);
		free(pc);
		free(t);
		//flash->deinit();
	
    mbed_start_application(POST_APPLICATION_ADDR);
}


void apply_update(Serial *ps, uint32_t address)
{

    FlashIAP *flash = new FlashIAP;  
	Timer *t = new Timer;
    const uint32_t page_size = flash->get_page_size();
    char *page_buffer = new char[page_size];
    uint32_t addr = address;
    uint32_t next_sector = addr + flash->get_sector_size(addr);	
    bool sector_erased = false;
	ps->printf("Page Size: %d \r\n",page_size);
	ps->printf("Address: %X \r\n",addr);
	ps->printf("Sector Size: %d \r\n",flash->get_sector_size(addr));
	flash->init();
	t->reset();
	t->start();
    while (t->read()<10) {

        // Read data for this page
		if(ps->readable())
		{
			t->reset();
			memset(page_buffer, 0, sizeof(page_buffer));
			page_buffer[0] = ps->getc();

			// Erase this page if it hasn't been erased
			if (!sector_erased) {
				flash->erase(addr, flash->get_sector_size(addr));
				sector_erased = true;
			}

			// Program page
			flash->program(page_buffer, addr, page_size);

			addr += page_size;
			if (addr >= next_sector) {
				next_sector = addr + flash->get_sector_size(addr);
				sector_erased = false;
			}
			ps->putc(page_buffer[0]);
		}
	}
	t->stop();
    ps->printf("Flashed 100%%\r\n");
	free(t);
	flash->deinit();
	free(flash);
    delete[] page_buffer;

   
}